"use client";
import { Card, CardContent } from "@/components/ui/card";
import FinanceDashboard from "./components/FinanceDashboard";
import OperationsDashboard from "./components/OperationsDashboard";
import SADashboard from "./components/SADashboard";
import MDDashboard from "./components/MDDashboard";
import DDashboard from "./components/DDashboard";
import RTDashboard from "./components/RTDashboard";
import MADashboard from "./components/MADashboard";
import { useTranslations } from "next-intl";
import HomeStats from "./components/home-stats";
import { useRouter } from "next/navigation";
import Model from "./components/Model";
import Link from "next/link";
import { getWithToken } from "@/Helper/common";
import RechargeServices from "./components/RechargeServices";
import { Input } from "@/components/ui/input";
import { Label } from "@/components/ui/label";
import React, { useEffect, useRef, useState } from "react";
import LayoutLoader from "@/components/layout-loader";
import PlanList from "../profile/components/table";

import {
  Dialog,
  DialogClose,
  DialogContent,
  DialogFooter,
  DialogHeader,
  DialogTitle,
  DialogTrigger,
} from "@/components/ui/dialog";
import { ClipLoader } from "react-spinners";
import moment from "moment";

import {
  CardHeader,
  CardTitle,
} from "@/components/ui/card";

const Dashboard = () => {
  const router = useRouter();
  const [isOpen, setIsOpen] = useState(true);
  const [isOpenModal, setIsOpenModal] = useState(false);

  const [loading, setLoading] = useState(true);
  // const [kycDetailsData, setKycDetailsData] = useState([]);
  const [kycDetailsData, setKycDetailsData] = useState([]);
  const [userDetailsData, setUserDetailsData] = useState([]);
  const [singleNewsData, setSingNewsData] = useState([]);
  const [newsData, setNewsData] = useState([]);
  const lang = useTranslations("Index");

  const getLocalDateString = () => {
    const date = new Date();
    const offset = date.getTimezoneOffset() * 60000; // Get offset in milliseconds
    const localDate = new Date(date.getTime() - offset);
    return localDate.toISOString().split('T')[0]; // Return YYYY-MM-DD format
  };

  const [formDate, setFromDate] = React.useState(getLocalDateString);
  const [toDate, setToDate] = React.useState(getLocalDateString);

  const handleClose = () => {
    setIsOpen(false);
    setIsOpenModal(false);
  };

  const singleNewsDataSet = (item) => {
    setSingNewsData(item);
    setIsOpenModal(true);
  };

  useEffect(() => {
    fetchKycData();

  }, []);

  var apiCall = true;

  const fetchKycData = async () => {
    try {

      if (apiCall) {

        apiCall = false;

        const apiResData = await getWithToken("get-kyc-details");
        if (apiResData.error === false) {
          // setKycDetailsDataAll(apiResData);
          setKycDetailsData(apiResData.data);
          setUserDetailsData(apiResData.userData);
          // setLoading(false);
        }

        // const apiResNewsData = await getWithToken("news/get-news-data");
        // if (apiResNewsData?.error === false) {
        //   setNewsData(apiResNewsData.result);

        // }

        setLoading(false);
      }

    } catch (error) {
      console.error("Error fetching:", error);
      setLoading(false);
    }
  };

  return (
    <>

      {userDetailsData?.unique_id != "ADMIN" &&
        kycDetailsData?.kyc_status == "Pending" ? (
        <Model />
      ) : null}

      {
        loading ?
          <LayoutLoader />

          :

          <div className="space-y-6 ml-5">
            <div className="flex items-center flex-wrap justify-between gap-4 relative">

              {
                // newsData && newsData?.length > 0 ?

                //   <div className="marquee absolute mt-3">
                //     <div className="marquee-content text-lg">
                //       {

                //         newsData.map((item, index) => {
                //           return (
                //             <span key={index}>
                //               <a href="#" onClick={() => singleNewsDataSet(item)}>{item.title}</a>
                //             </span>
                //           );
                //         })
                //       }

                //     </div>


                //     <div>
                //       {

                //         <Dialog open={isOpenModal} onOpenChange={handleClose}>
                //           {" "}
                //           <DialogTrigger asChild>
                //           </DialogTrigger>
                //           <DialogContent>
                //             <div className="flex flex-col items-center">
                //               <div className="col-span-12 lg:col-span-12 mx-auto">
                //                 <h1>{singleNewsData?.title}</h1>
                //                 {/* <p className="mt-5 mb-5"><div dangerouslySetInnerHTML={{ __html: singleNewsData?.description }}></div></p> */}
                //                 <img src={singleNewsData?.attachment_files} alt="Modal Content"
                //                   className="w-full h-100" />
                //               </div>
                //             </div>
                //           </DialogContent>
                //         </Dialog>

                //       }

                //     </div>

                //   </div>

                //   : null
              }


              <div className="flex text-2xl font-medium text-default-800" style={{ justifyContent: 'space-between', width: '100%' }}>
                {loading == false ? lang("Analytics_Dashboard") : null}

                {
                  userDetailsData.designation_id != 1 ?


                    <div className="flex flex-wrap md:flex-nowrap gap-4">
                      <div className="flex" style={{ alignItems: 'center' }}>
                        <Label htmlFor="Old Password">From &nbsp;&nbsp;</Label>
                        <Input
                          type="Date"
                          placeholder="Date"
                          value={formDate}
                          onChange={(e) => setFromDate(e.target.value)}
                        />
                      </div>
                      <div className="flex" style={{ alignItems: 'center' }}>
                        <Label htmlFor="Date">To &nbsp;&nbsp;</Label>
                        <Input
                          type="Date"
                          placeholder="b"
                          value={toDate}
                          onChange={(e) => setToDate(e.target.value)}
                        />
                      </div>
                    </div>

                    : null

                }

              </div>
              {userDetailsData.unique_id != "ADMIN" &&
                kycDetailsData.kyc_status == "Pending" ? (
                <div
                  style={{ height: "50px" }}
                  className="flex  items-center bg-warning  w-full"
                >
                  <p className=" text-white font-bold text-lg mx-5">
                    {lang("Warning")}{" "}
                    <Link
                      href="/admin/kyc-update"
                      prefetch={true}
                      class="underline"
                    >
                      {lang("Click_here")}
                    </Link>{" "}
                    {lang("Update_Now")}
                  </p>
                </div>
              ) : kycDetailsData.kyc_status == "Update" ?

                <div
                  style={{ height: "50px" }}
                  className="flex  items-center bg-green-500  w-full"
                >
                  <p className=" text-white font-bold text-lg mx-5">
                    We would like to inform you that your KYC (Know Your Customer) verification is currently under review. Please wait for approval.
                  </p>
                </div>

                : kycDetailsData.kyc_status == "Rejected" ?

                  <div

                    className="items-center bg-red-500  w-full"
                  >
                    <p className=" text-white font-bold text-lg mx-5">
                      {lang("Kyc_rejected")} &nbsp;
                      <Link
                        href="/admin/kyc-update"
                        prefetch={true}
                        class="underline text-black"
                      >
                        {lang("Click_here")}
                      </Link> {lang("Kyc_rejected_cont")}
                    </p>
                    <p className=" text-black font-bold text-sm mx-5">
                      {lang("Rejected_remark")} {kycDetailsData.kyc_remark}
                    </p>
                  </div>

                  : <div
                      style={{ height: "50px" }}
                      className="flex  items-center bg-green-500  w-full"
                    >
                      <p className=" text-white font-bold text-lg mx-5">
                        {lang("Kyc_approved")}.
                      </p>
                    </div>

              }
            </div>
            {userDetailsData.designation_id == "1" ?

              <SADashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

              : userDetailsData.designation_id == "2" ?

                <MADashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

                : userDetailsData.designation_id == "3" ?

                  <MDDashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

                  : userDetailsData.designation_id == "4" ?

                    <DDashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

                    : userDetailsData.designation_id == "5" ?

                      <RTDashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

                      : userDetailsData.designation_id == "6" ?

                        <SADashboard formDate={formDate} toDate={toDate} kycDetailsData1={kycDetailsData} userDetailsData1={userDetailsData} />

                        : userDetailsData.designation_id == "7" ?

                          <OperationsDashboard formDate={formDate} toDate={toDate} />

                          : userDetailsData.designation_id == "8" ?

                            <FinanceDashboard formDate={formDate} toDate={toDate} />

                            : null
            }

          </div>
      }

      <div className="space-y-6 ml-5 mt-5">
        {
          userDetailsData ?

            <Card>
              <CardHeader>
                <CardTitle>
                  <div style={{ display: "flex", justifyContent: "space-between" }}>
                    {/* User Login History */}
                    {lang("User_Login_History")}

                  </div>
                </CardTitle>
              </CardHeader>
              <CardContent className="p-0">
                <div className="px-4 space-y-4 gap-2 lg:space-y-0 lg:grid lg:grid-cols-1 gap-6 mx-auto ">
                  <div className="col-span-2 mb-5">
                    <PlanList />
                  </div>
                </div>
              </CardContent>
            </Card >

            : null
        }

      </div>

    </>
  );
};

export default Dashboard;
